import gnu.hylafax.Client;
import gnu.hylafax.HylaFAXClient;
import gnu.hylafax.HylaFAXClientProtocol;
import gnu.hylafax.Job;
import gnu.inet.ftp.FtpClientProtocol;
import gnu.inet.ftp.ServerResponseException;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class FaxSender {
  public static void main(String[] args)
  {
    HylaFAXClient c = new HylaFAXClient();
    try {
      c.setSocketTimeout(0); // default timeout is 10000 (10 seconds), which may be too short when sending large files.
                             // Setting to 0 disables the timeout
      // Connect to HylaFAX
      c.open("10.10.12.100");
      c.user("david");
      // c.pass("password"); // Uncomment if password is required

      c.mode(FtpClientProtocol.MODE_ZLIB);
      c.type(FtpClientProtocol.TYPE_IMAGE);

      //Create a new job.
      Job job = c.createJob();

      //Set the job properties.  This can be any jparm property specified
      //in the hfaxd manual page.  If there is not a native function for
      //the property you are trying to set, use the setProperty function
      //to set it.
      job.setFromUser("david@example.com");
      job.setKilltime("032359");
      job.setMaximumDials(12);
      job.setMaximumTries(3);
      job.setPriority(127);
      job.setVerticalResolution(job.RESOLUTION_MEDIUM);
      job.setNotifyType(c.NOTIFY_DONE);
      job.setChopThreshold(3);
      job.setDialstring("12125558774");

      FileInputStream file = new FileInputStream("testfax.pdf");
      // Open a passive mode (PASV) connection
      c.setPassive(true);
      String remote_filename = c.putTemporary(file);

      job.addDocument(remote_filename);

      // Submit the job to the scheduler
      c.submit(job);

      System.out.println("Job ID: " + job.getId());

    } catch (Exception e) {
      e.printStackTrace();
    } finally {
      //Close the connection.
      try {
        c.quit();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }
}
